Subject: Re: [RFT net-next 0/6] devlink: expose instance locking and simplify port splitting

From: Leon Romanovsky <[email-masked]>
Date: Fri, 11 Mar 2022 08:30:20 +0200

On Thu, Mar 10, 2022 at 12:13:48PM -0800, Jakub Kicinski wrote:
> On Thu, 10 Mar 2022 11:07:14 +0200 Leon Romanovsky wrote:
> > On Wed, Mar 09, 2022 at 04:16:26PM -0800, Jakub Kicinski wrote:
> > > This series puts the devlink ports fully under the devlink instance
> > > lock's protection. As discussed in the past it implements my preferred
> > > solution of exposing the instance lock to the drivers. This way drivers
> > > which want to support port splitting can lock the devlink instance
> > > themselves on the probe path, and we can take that lock in the core
> > > on the split/unsplit paths.
> > > 
> > > nfp and mlxsw are converted, with slightly deeper changes done in
> > > nfp since I'm more familiar with that driver.
> > > 
> > > Now that the devlink port is protected we can pass a pointer to
> > > the drivers, instead of passing a port index and forcing the drivers
> > > to do their own lookups. Both nfp and mlxsw can container_of() to
> > > their own structures.
> > > 
> > > I'd appreciate some testing, I don't have access to this HW.
> >
> > Thanks for pursuing in cleanup this devlink mess.
> > 
> > Do you plan to send a series that removes devlink_mutex?
> 
> I would like to convert enough to explicit locking to allow simpler
> reload handling. I'm happy to leave devlink_mutex removal to someone
> else, but if there are no takers will do it as well. Let's see how 
> it goes.

Alright, let's see.

The main obstacle to remove devlink_mutex was netdevsim port creation sysfs,
so after your locking series, that change will be more or less trivial.

Thanks